// FIDlibDLL.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <stdio.h>
#include "fidlib.h"
#include "fidlibdll.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

// entry points to call the actual routines
DLL_PORT void *
run_new(void *filt, double (**funcpp)(void *,double))
{
	return (void *)(fid_run_new((FidFilter *)filt,funcpp));
}

//
//	Create a new instance of the given filter
//

DLL_PORT void *run_newbuf(void *run)
{
	return fid_run_newbuf(run);
}

//
//	Find the space required for a filter buffer
//

DLL_PORT int run_bufsize(void *run)
{
	return fid_run_bufsize(run);
}

//
//	Initialise a filter buffer allocated separately.  Usually
//	fid_run_newbuf() is easier, but in the case where filter
//	buffers must be allocated as part of a larger structure, a
//	call to fid_run_newbuf can be replaced with a call to
//	fid_run_bufsize() to get the space required, and then a call
//	to fid_run_initbuf() once it has been allocated.
//

DLL_PORT void run_initbuf(void *run, void *buf)
{
	fid_run_initbuf(run,buf);
}

//
//	Reinitialise an instance of the filter, allowing it to start
//	afresh.  It assumes that the buffer was correctly initialised
//	previously, either through a call to fid_run_newbuf() or
//	fid_run_initbuf().
//

DLL_PORT void run_zapbuf(void *buf)
{
	fid_run_zapbuf(buf);
}

//
//	Delete an instance
//

DLL_PORT void run_freebuf(void *runbuf)
{
	fid_run_freebuf(runbuf);
}

//
//	Delete the filter
//

DLL_PORT void run_free(void *run)
{
	fid_run_free(run);
}


//
//	Design a filter.  Spec and range are passed as arguments.  The
//	return value is a pointer to a FidFilter as documented earlier
//	in this file.  This needs to be free()d once finished with.
//
//	If 'f_adj' is set, then the frequencies fed to the design code
//	are adjusted automatically to get true sqrt(0.5) (-3.01dB)
//	values at the provided frequencies.  (This is obviously a
//	slower operation)
//
//	If 'descp' is non-0, then a long description of the filter is
//	generated and returned as a strdup'd string at the given
//	location.
//
//	Any problem with the spec causes the program to die with an
//	error message.
//
//	'spec' gives the specification string.  The 'rate' argument
//	gives the sampling rate for the data that will be passed to
//	the filter.  This is only used to interpret the frequencies
//	given in the spec or given in 'freq0' and 'freq1'.  Use 1.0 if
//	the frequencies are given as a proportion of the sampling
//	rate, in the range 0 to 0.5.  'freq0' and 'freq1' provide the
//	default frequency or frequency range if this is not included
//	in the specification string.  These should be -ve if there is
//	no default range (causing an error if they are omitted from
//	the 'spec').
//
DLL_PORT void *
design(char *spec, double rate, double freq0, double freq1, int f_adj, char **descp)
{
	return (void *)fid_design(spec,rate,freq0,freq1,f_adj,descp);
}

//
//	Get the response of a filter at the given frequency (expressed
//	as a proportion of the sampling rate, 0->0.5).
//


DLL_PORT double response(void *filt, double freq)
{
	return fid_response((FidFilter *)filt,freq);
}


DLL_PORT void set_error_handler(void (*rout)(char*))
{
	fid_set_error_handler(rout);
}


#ifdef _MANAGED
#pragma managed(pop)
#endif

