#ifndef __FDILIBDLLH__
#define __FDILIBDLLH__

#ifdef __cplusplus
extern "C" 
{
#endif

#ifdef DLL_PORT
#undef DLL_PORT
#endif
#ifdef VBDLL
#undef VBDLL
#endif

#ifdef STATICBUILD
#define DLL_PORT
#define VBDLL

#else

#ifdef EXPORTBUILD
#define DLL_PORT __declspec(dllexport)
#define VBDLL __stdcall

#else

#define DLL_PORT __declspec(dllimport)
#define VBDLL __stdcall

#endif
#endif
// here go the entry point definitions
/*


What the filter definitions look like

//	  LpBu4/20.4	Lowpass butterworth, 4th order, -3.01dB at 20.4Hz
//	  BpBu2/3-4	Bandpass butterworth, 2nd order, from 3 to 4Hz
//	  BpBu2/=3-4	Same filter, but adjusted exactly to the range given




	struct FidFilter {
		short typ;		// Type of filter element 'I' IIR, 'F' FIR, or 0 for end of list
		short cbm;		// Constant bitmap.  Bits 0..14, if set, indicate that val[0..14]
		//   is a constant across changes in frequency for this filter type
		//   Bit 15, if set, indicates that val[15..inf] are constant.
		int len;		// Number of doubles stored in val[], or 0 for end of list
		double val[1];
	};
	typedef struct Run {
		int magic;		// Magic: 0x64966325
		int buf_size;	// Length of working buffer required in doubles	
		double *coef;	// Coefficient list
		char *cmd;		// Command list
	} Run;

	typedef struct RunBuf {
		double *coef;
		char *cmd;
		int mov_cnt;		// Number of bytes to memmove
		double buf[0];
	} RunBuf;
*/

//
//	Create an instance of a filter, ready to run.  This returns a
//	void* handle, and a function to call to execute the filter.
//	Working buffers for the filter instances must be allocated
//	separately using run_newbuf().  This allows many
//	simultaneous instances of the filter to be run.  
//
//	The sub-filters are executed in the precise order that they
//	are given.  This may lead to some inefficiency.  Normally when
//	an IIR filter is followed by an FIR filter, the buffers can be
//	shared.  However, if the sub-filters are not in IIR/FIR pairs,
//	then extra memory accesses are required.
//
//	In any case, factors are extracted from IIR filters (so that
//	the first coefficient is 1), and single-element FIR filters
//	are merged into the global gain factor, and are ignored.
//
//	The returned handle must be released using run_free().
//
DLL_PORT void *run_new(void *filt, double (**funcpp)(void *,double));

//
//	Create a new instance of the given filter
//

DLL_PORT void *run_newbuf(void *run) ;

//
//	Find the space required for a filter buffer
//

DLL_PORT int run_bufsize(void *run);

//
//	Initialise a filter buffer allocated separately.  Usually
//	fid_run_newbuf() is easier, but in the case where filter
//	buffers must be allocated as part of a larger structure, a
//	call to fid_run_newbuf can be replaced with a call to
//	fid_run_bufsize() to get the space required, and then a call
//	to fid_run_initbuf() once it has been allocated.
//

DLL_PORT void run_initbuf(void *run, void *buf) ;

//
//	Reinitialise an instance of the filter, allowing it to start
//	afresh.  It assumes that the buffer was correctly initialised
//	previously, either through a call to fid_run_newbuf() or
//	fid_run_initbuf().
//

DLL_PORT void run_zapbuf(void *buf);

//
//	Delete an instance
//

DLL_PORT void run_freebuf(void *runbuf);

//
//	Delete the filter
//

DLL_PORT void run_free(void *run);


//
//	Design a filter.  Spec and range are passed as arguments.  The
//	return value is a pointer to a FidFilter as documented earlier
//	in this file.  This needs to be free()d once finished with.
//
//	If 'f_adj' is set, then the frequencies fed to the design code
//	are adjusted automatically to get true sqrt(0.5) (-3.01dB)
//	values at the provided frequencies.  (This is obviously a
//	slower operation)
//
//	If 'descp' is non-0, then a long description of the filter is
//	generated and returned as a strdup'd string at the given
//	location.
//
//	Any problem with the spec causes the program to die with an
//	error message.
//
//	'spec' gives the specification string.  The 'rate' argument
//	gives the sampling rate for the data that will be passed to
//	the filter.  This is only used to interpret the frequencies
//	given in the spec or given in 'freq0' and 'freq1'.  Use 1.0 if
//	the frequencies are given as a proportion of the sampling
//	rate, in the range 0 to 0.5.  'freq0' and 'freq1' provide the
//	default frequency or frequency range if this is not included
//	in the specification string.  These should be -ve if there is
//	no default range (causing an error if they are omitted from
//	the 'spec').
//
DLL_PORT void *design(char *spec, double rate, double freq0, double freq1, int f_adj, char **descp);

//
//	Get the response of a filter at the given frequency (expressed
//	as a proportion of the sampling rate, 0->0.5).
//


DLL_PORT double response(void *filt, double freq);


DLL_PORT void set_error_handler(void (*rout)(char*));

#ifdef __cplusplus
}
#endif

#endif